local Board = {}

Board.newBoard = function(manager, level, gameMode, topGroup, popGroup )


    local piece = require "Piece"
    local mydata = require "mydata"
    local _slots = {}

    local _cellWidth = mydata.HorizontalDistance         --level.board.cellWidth
    local _cellHeight = mydata.VerticalDistance                    --level.board.cellHeight
    local distUnit = _cellWidth*_cellWidth+_cellHeight*_cellHeight
    local centerX = mydata.centerX
    local centerY = mydata.centerY
    local HorizontalDistance = 2*mydata.HorizontalDistance 
    local VerticalDistance = 2*mydata.VerticalDistance
    local fullw = mydata.fullw
    local fullh = mydata.fullh
    local width = application:getContentWidth()
    local height = application:getContentHeight()
    local centerX = width/2      --mydata.centerX
    local centerY = height/2    --mydata.centerY
    local dx = mydata.dx
    local dy = mydata.dy
    local _numRow = 6
    local _numCol = 7

    local actionPiece = nil
    local _count = 0
    local _selectedGems = {}
    local newSlots

    local xS = mydata.xS*0.8

    mydata.Base = TexturePack.new( "gfx/Base.txt","gfx/Base.png",  true)

    local _board = Sprite.new()



    local function _basePiece(kind, col, row)

            --mydata.colorFile has all the info about colors

            local piece = Piece.newPiece(_board, kind, false)
            piece:setScale(piece:getScaleX()*1.1, piece:getScaleY()*1.1)           --0.95        
            _board:addChild(piece)

            _slots[_numRow*col+row] = piece

            piece:setX( centerX - (_numCol-1)/2*_cellWidth+col*_cellWidth )                           --_cellWidth * col  + (_cellWidth * 0.5)
            piece:setY( centerY - (_numRow-1)/2*_cellHeight +_cellHeight * row )
            piece.col = col
            piece.row = row
            if col%2==0 then
                piece:setY( piece:getY() + (_cellHeight * 0.5) )
                if row == _numRow-1 then
                    _slots[_numRow*col+row] = nil
                    if piece then
                        piece:removeFromParent()
                        piece=nil
                    end
                    
                end 

            end

            
        

            return piece
        end


    local function Setup()

        for i=0,7-1 do
            for j=0,6-1 do

            	local kind = math.random(1, 3)    
            	_basePiece(kind, i, j)   

            end
        end

        _selectedGems[1] = _slots[8]
        _selectedGems[2] = _slots[12]
        _selectedGems[3] = _slots[13]

        newSlots = Sprite.new()
        _board:addChild(newSlots)

        for i=1, #_selectedGems do
            local p = _selectedGems[i]

            local piece = Piece.newPiece(_board, p.kind, true)
            piece:setScale(piece:getScaleX()*1.5, piece:getScaleY()*1.5)           --0.95   

            newSlots:addChild(piece)
            piece:setPosition(p:getX(), p:getY())

        end

        function newSlots:onMouseDown(event)

            print("NEWSLOTS Down 1")
                            
            if self:hitTestPoint(event.x, event.y)  then
                                    
                event:stopPropagation()

                print("NEWSLOTS Down 2")
                self.focus = true

                self.x0 = event.x
                self.y0 = event.y  

                mydata.intitalX = newSlots:getX()
                mydata.intitalY = newSlots:getY()
                newSlots.diffX = newSlots:getX()-newSlots.x0
                newSlots.diffY = newSlots:getY()-newSlots.y0                                        

            end    


        end

        function newSlots:onMouseMove(event)

            if self.focus then
               
            
                if not self:hitTestPoint(event.x, event.y) then
                    self.focus = false

                end
                    
                    event:stopPropagation()
                    print("MOVING newSlots")
                
                    local dx = event.x - newSlots.x0
                    local dy = event.y - newSlots.y0
             
                    newSlots:setX(newSlots:getX() + dx)
                    newSlots:setY(newSlots:getY() + dy)
             
                    newSlots.x0 = event.x
                    newSlots.y0 = event.y

                    -----------------------------------------------------------

                    for s=1, newSlots:getNumChildren() do
                        local p = newSlots:getChildAt(s)

                        if p then 

                            for i=0,7-1 do
                                for j=0,6-1 do

                                    local piece = _slots[_numRow*i+j] 
                                    if piece and piece:below(p, newSlots) and newSlots.focus then
                                        print("BELOW")
                                    end

                                end
                            end


                        else print("bb,,,bb,,b")       
                        end

                    end


            end


        end

        function newSlots:onMouseUp(event)


            --if self.focus then                    

                print("NEWSLOTS Up") 
                event:stopPropagation()  

                newSlots.focus = false 

                newSlots:removeFromParent()
                newSlots = nil

            --end 

        end

        function newSlots:onTouchesBegin(event)

            if self.focus then
                event:stopPropagation()
            end

        end

        function newSlots:onTouchesMove(event)

            if self.focus then
                event:stopPropagation()
            end

        end

        function newSlots:onTouchesEnd(event)

            if self.focus then
                event:stopPropagation()
            end

        end

        function newSlots:onTouchesCancel(event)

            if self.focus then
                event:stopPropagation()
            end

        end

        newSlots.focus = false
        newSlots:addEventListener(Event.MOUSE_DOWN, newSlots.onMouseDown, newSlots)
        newSlots:addEventListener(Event.MOUSE_MOVE, newSlots.onMouseMove, newSlots)
        newSlots:addEventListener(Event.MOUSE_UP, newSlots.onMouseUp, newSlots)

        newSlots:addEventListener(Event.TOUCHES_BEGIN, newSlots.onTouchesBegin, newSlots)
        newSlots:addEventListener(Event.TOUCHES_MOVE, newSlots.onTouchesMove, newSlots)
        newSlots:addEventListener(Event.TOUCHES_END, newSlots.onTouchesEnd, newSlots)
        newSlots:addEventListener(Event.TOUCHES_CANCEL, newSlots.onTouchesCancel, newSlots)

    end



    Setup()


    return _board


end

return Board